HDY_20113_Jinatchapak/Models/Product.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace HDY_20113_Jinatchapak.Models
{
    [Table("products")]
    public class Product
    {

        [Column("product_id")]
        /* PK */
        [Key]
        /* auto increment */
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        /* show msg view*/
        [Display(Name = "สินค้า ID")]
        public int ProductId { get; set; }

        [Column("product_name")]
        /* Not Null*/
        [Required]
        /* show msg view*/
        [Display(Name = "ชื่อสินค้า")]
        public string ProductName { get; set; }

        [Column("quantity_per_unit")]
        /* show msg view*/
        [Display(Name = "ปริมาณสินค้าต่อหน่วย")]
        /* Not Null*/
        [Required]
        public string QuantityPerUnit { get; set; }

        [Column("unit_price")]
        /* show msg view*/
        [Display(Name = "ราคาต่อหน่วย")]
        /* Not Null*/
        [Required]
        /* specify type DB*/
        //[Column(TypeName = "decimal(10, 2)")]
        public decimal UnitPrice { get; set; }

        [Column("unit_in_stock")]
        /* show msg view*/
        [Display(Name = "จำนวนสินค้าในสต๊อก")]
        /* Not Null*/
        [Required]
        public int UnitInStock { get; set; }


        [Column("discontinued")]
        /* show msg view*/
        [Display(Name = "ปิดจำหน่าย")]
        public int Discontinued { get; set; }

        [Column("category_id")]
        /* Relationnal FK*/
        public int CategoryId { get; set; } //CategoryId
        public Category category { get; set; } //Category

        public virtual ICollection<Images> img { get; set; } = new HashSet<Images>();
    }
}

HDY_20113_Jinatchapak/Controllers/ProductsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using HDY_20113_Jinatchapak.Data;
using HDY_20113_Jinatchapak.Models;
namespace HDY_20113_Jinatchapak.Controllers
{
    public class ProductsController : Controller
    {
        private AppDb db = new AppDb();

        // GET: Products
        public ActionResult Index()
        {
            var products = db.Products.Include(p => p.category);
            return View(products.ToList());
        }

        // GET: Products/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            return View(product);
        }
        [Route("{controller}/DetailImg/{ProductId}")]
        public ActionResult DetailImg(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("View", "Images", null);

            }
            //var product = (from img in db.Images.AsNoTracking()
            //                 join pro in db.Products.AsNoTracking() on img.ProductId equals pro.ProductId
            //                 where img.ImageId == id
            //                 select pro).ToList();
            var product = db.Products.Include(p => p.img).Where(p => p.ProductId == id).FirstOrDefault();

            if (product == null) return HttpNotFound();

            //var images = db.Images.Find(product.ProductId);
            //ViewBag.ProductName = product.ProductName;
            // return View(images);
            return PartialView(product);
        }

        // GET: Products/Create
        public ActionResult Create()
        {
            ViewBag.CategoryId = new SelectList(db.Categories, "CategoryId", "CategoryName");
            return View();
        }

        // POST: Products/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "ProductId,ProductName,QuantityPerUnit,UnitPrice,UnitInStock,Discontinued,ImgPath,CategoryId")] Product product)
        {
            if (ModelState.IsValid)
            {
                db.Products.Add(product);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.CategoryId = new SelectList(db.Categories, "CategoryId", "CategoryName", product.CategoryId);
            return View(product);
        }

        // GET: Images/Create
        public ActionResult CreateImage(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            ViewBag.Product = db.Products.Include(p=>p.img).Where(p=> p.ProductId == id).ToList();
            //ViewBag.ProductId = new SelectList(db.Products, "ProductId", "ProductName");
            return View();
        }

        [HttpPost]
        [Route("{controller}/CreateImage/{ProductId}")]
        [ValidateAntiForgeryToken]
        //public ActionResult Create()
        public ActionResult CreateImage(int id, [Bind(Include = "ImageId,ImagePath,ProductId")] Images images)
        {
            var productId = db.Products.Find(id).ProductId;
            
            if (ModelState.IsValid)
            {
                var p = db.Products.Find(id);
                p.img.Add(images);
                db.SaveChanges();
                //return RedirectToAction("Index");
                return RedirectToAction(nameof(Details), new { id = images.ProductId });
            }

            ViewBag.ProductId = new SelectList(db.Products, "ProductId", "ProductName", images.ProductId);
            
            return View(images);
        }

        // GET: Products/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            ViewBag.CategoryId = new SelectList(db.Categories, "CategoryId", "CategoryName", product.CategoryId);
            return View(product);
        }

        // POST: Products/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "ProductId,ProductName,QuantityPerUnit,UnitPrice,UnitInStock,Discontinued,ImgPath,CategoryId")] Product product)
        {
            if (ModelState.IsValid)
            {
                db.Entry(product).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.CategoryId = new SelectList(db.Categories, "CategoryId", "CategoryName", product.CategoryId);
            return View(product);
        }

        // GET: Products/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.Products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            return View(product);
        }

        // POST: Products/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Product product = db.Products.Find(id);
            db.Products.Remove(product);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }


    }
}

HDY_20113_Jinatchapak/Views/Products/Create.cshtml
@model HDY_20113_Jinatchapak.Models.Product

@{
    ViewBag.Title = "Create";
}

<h2>Create</h2>

@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
<div class="form-horizontal">
    <h4>Product</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="form-group">
        @Html.LabelFor(model => model.ProductName, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.ProductName, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.ProductName, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.QuantityPerUnit, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.QuantityPerUnit, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.QuantityPerUnit, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.UnitPrice, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.UnitPrice, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.UnitPrice, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.UnitInStock, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.UnitInStock, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.UnitInStock, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Discontinued, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Discontinued, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Discontinued, "", new { @class = "text-danger" })
        </div>
    </div>


    <div class="form-group">
        @Html.LabelFor(model => model.CategoryId, "CategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("CategoryId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.CategoryId, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Create" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

HDY_20113_Jinatchapak/Views/Products/CreateImage.cshtml
@using HDY_20113_Jinatchapak.Models
@model Images
    @{

        var p = (Product)ViewBag.Product;
     }

@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Images</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.ImagePath, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ImagePath, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ImagePath, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProductId, "ProductId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <input type="text" name="ProductName" value="@p.ProductName" disabled />
                <input type="hidden" name="ProductId" value="@p.ProductId"  />
                
                @*@Html.DropDownList("ProductId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.ProductId, "", new { @class = "text-danger" })*@
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

HDY_20113_Jinatchapak/Views/Products/Delete.cshtml
@model HDY_20113_Jinatchapak.Models.Product

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Product</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.category.CategoryName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.category.CategoryName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProductName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProductName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.QuantityPerUnit)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.QuantityPerUnit)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.UnitPrice)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.UnitPrice)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.UnitInStock)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.UnitInStock)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Discontinued)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Discontinued)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

HDY_20113_Jinatchapak/Views/Products/DetailImg.cshtml
@using HDY_20113_Jinatchapak.Models
@model Product


<h2>Index</h2>

<p>

    <a href="~/Products/CreateImage/@Model.ProductId">เพิ่ม</a>
</p>
<table class="table table-striped">
    <thead>
        <tr>
            <th>
                รูป
            </th>
            <th></th>
        </tr>

    </thead>
<tbody>
    @foreach (var itm in Model.img) { 
    <tr>
        <td>
            
            <img alt="" style="width:50px; height:50px;" src="@itm.ImagePath" />
            
        </td>
        <td>
            @itm.ImageId
        </td>
    </tr>
    }
</tbody>    
    

</table>

HDY_20113_Jinatchapak/Views/Products/Details.cshtml
@model HDY_20113_Jinatchapak.Models.Product

@{
    ViewBag.Title = "Details";
}

<h2>Details</h2>

<div>
    <h4>Product</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.category.CategoryName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.category.CategoryName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProductName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProductName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.QuantityPerUnit)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.QuantityPerUnit)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.UnitPrice)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.UnitPrice)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.UnitInStock)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.UnitInStock)
        </dd>





    </dl>
   
</div>
<div id="Img">

</div>
<p>
    @Html.ActionLink("Edit", "Edit", new { id = Model.ProductId }) |
    @Html.ActionLink("Back to List", "Index")
</p>


@section Scripts{
    <script>
        GetPage();

        function GetPage() {
            const url = '@Url.Action("DetailImg", "Products", new { id = Model.ProductId})';

            $.get(url).then((res) => {
                $('#Img').html(res);
            });
        }
    </script>
}

HDY_20113_Jinatchapak/Views/Products/Edit.cshtml
@model HDY_20113_Jinatchapak.Models.Product

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Product</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.ProductId)

        <div class="form-group">
            @Html.LabelFor(model => model.ProductName, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ProductName, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ProductName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.QuantityPerUnit, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.QuantityPerUnit, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.QuantityPerUnit, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.UnitPrice, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.UnitPrice, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.UnitPrice, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.UnitInStock, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.UnitInStock, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.UnitInStock, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Discontinued, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Discontinued, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Discontinued, "", new { @class = "text-danger" })
            </div>
        </div>



        <div class="form-group">
            @Html.LabelFor(model => model.CategoryId, "CategoryId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("CategoryId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.CategoryId, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

HDY_20113_Jinatchapak/Views/Products/Index.cshtml
@model IEnumerable<HDY_20113_Jinatchapak.Models.Product>

@{
    ViewBag.Title = "Index";
}

<h2>รายการสินค้า</h2>
@*Html.ActionLink("เพิ่ม", "Create")*@
<a href="/Products/Create" class="btn btn-outline-dark float-right" style="margin-bottom:20px;">เพิ่ม</a>
<table class="table table-responsive">
    <thead class="thead-dark">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.category.CategoryName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.ProductName)
            </th>

            <th>
                @Html.DisplayNameFor(model => model.UnitPrice)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.UnitInStock)
            </th>


            <th></th>
        </tr>
    </thead>

    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.category.CategoryName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.ProductName)
                </td>

                <td>
                    @Html.DisplayFor(modelItem => item.UnitPrice)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.UnitInStock)
                </td>

                <td>

                    <a href="/Products/Edit/@item.ProductId" class="btn btn-outline-warning">แก้ไข</a>
                    <a href="/Products/Details/@item.ProductId" class="btn btn-outline-info">รายละเอียด</a>
                    <a href="/Products/Delete/@item.ProductId" class="btn btn-outline-danger">ลบ</a>
                    <a href="/Images/Index/@item.ProductId" class="btn btn-outline-secondary">รูปภาพ</a>

                    @*Html.ActionLink("เพิ่ม", "Edit",  , htmlAttributes: new { @class = "btn btn-outline-dark", id = item.CategoryId })*@
                    @*Html.ActionLink("รายละเอียด", "Details", new { @class = "btn btn-outline-info", id = item.CategoryId })*@
                    @*Html.ActionLink("ลบ", "Delete", new { @class = "btn btn-outline-danger", id = item.CategoryId })*@
                </td>
            </tr>
        }

    </tbody>
</table>